'use strict';
var restSrv = '';

angular
  .module('rgbDemoApp', [
    'ngResource'
  ])
 .factory('DeviceFactory', function ($resource) {
        return $resource(restSrv+'/:id/:op/:port/:value', {}, {
            list: { method: 'GET', params: {op:'devices'}, isArray: true },
            ledSet: { method: 'GET', params: {id:'@id',op:'led',value:'@value'}, isArray: false },
            ledGet: { method: 'GET', params: {id:'@id',op:'led'}, isArray: false },
            digitalRead: { method: 'GET', params: {id:'@id',op:'digitalRead',port:'@port'}, isArray: false },
            digitalWrite: { method: 'GET', params: {id:'@id',op:'digitalWrite',port:'@port',value:'@value'}, isArray: false },
            analogRead: { method: 'GET', params: {id:'@id',op:'analogRead',port:'@port'}, isArray: false },
            analogRef: {method:'GET', params: {id:'@id',op:'analogReference',value:'@value'}, isArray: false }
        });
  }).controller('RGBController',function (DeviceFactory){
    var $this = this;
    this.red = false;
    this.green = false;
    this.blue = false;

    var redOnColor = 'red';
    var greenOnColor = 'green';
    var blueOnColor = 'blue';

    var offColor = 'lightgrey';

    this.redStyle = {'background-color':offColor};
    this.toggleRed = function (){
      DeviceFactory.digitalWrite({id:0,port:'c0',value:$this.red?0:1},function(){
        $this.red = !$this.red;
        if($this.red){
          $this.redStyle = {'background-color':redOnColor};
        } else {
          $this.redStyle = {'background-color':offColor};
        }
      });
    };

      this.greenStyle = {'background-color':offColor};
      this.toggleGreen = function (){
        DeviceFactory.digitalWrite({id:0,port:'c1',value:$this.green?0:1},function(){
          $this.green = !$this.green;
          if($this.green){
            $this.greenStyle = {'background-color':greenOnColor};
          } else {
            $this.greenStyle = {'background-color':offColor};
          }
        });
      };

    this.blueStyle = {'background-color':offColor};
    this.toggleBlue = function (){
      DeviceFactory.digitalWrite({id:0,port:'c2',value:$this.blue?0:1},function(){
        $this.blue = !$this.blue;
        if($this.blue){
          $this.blueStyle = {'background-color':blueOnColor};
        } else {
          $this.blueStyle = {'background-color':offColor};
        }
      });
    };



  });
